(require 'ert)
(require 'timeclock-list)
(require 'timeclock-report)

;; TODO - add tests for timeclock-ui-project-time-one-day with custom day start
;; times.

(defun interval-test (start target)
  "Basic logic used to derive 'gap' in
`timeclock-report-previous-week-start'"
  (cond ((= start target) 7)
        ((> start target) (- start target))
        ((< start target) (+ start (- 7 target)))))

(ert-deftest timeclock-ui-interval-test-0 ()
  (should (= (interval-test 0 0) 7))
  (should (= (interval-test 0 1) 6))
  (should (= (interval-test 0 2) 5))
  (should (= (interval-test 0 3) 4))
  (should (= (interval-test 0 4) 3))
  (should (= (interval-test 0 5) 2))
  (should (= (interval-test 0 6) 1)))

(ert-deftest timeclock-ui-interval-test-1 ()
  (should (= (interval-test 1 0) 1))
  (should (= (interval-test 1 1) 7))
  (should (= (interval-test 1 2) 6))
  (should (= (interval-test 1 3) 5))
  (should (= (interval-test 1 4) 4))
  (should (= (interval-test 1 5) 3))
  (should (= (interval-test 1 6) 2)))

(ert-deftest timeclock-ui-interval-test-2 ()
  (should (= (interval-test 2 0) 2))
  (should (= (interval-test 2 1) 1))
  (should (= (interval-test 2 2) 7))
  (should (= (interval-test 2 3) 6))
  (should (= (interval-test 2 4) 5))
  (should (= (interval-test 2 5) 4))
  (should (= (interval-test 2 6) 3)))

(ert-deftest timeclock-ui-interval-test-3 ()
  (should (= (interval-test 3 0) 3))
  (should (= (interval-test 3 1) 2))
  (should (= (interval-test 3 2) 1))
  (should (= (interval-test 3 3) 7))
  (should (= (interval-test 3 4) 6))
  (should (= (interval-test 3 5) 5))
  (should (= (interval-test 3 6) 4)))

(ert-deftest timeclock-ui-interval-test-4 ()
  (should (= (interval-test 4 0) 4))
  (should (= (interval-test 4 1) 3))
  (should (= (interval-test 4 2) 2))
  (should (= (interval-test 4 3) 1))
  (should (= (interval-test 4 4) 7))
  (should (= (interval-test 4 5) 6))
  (should (= (interval-test 4 6) 5)))

(ert-deftest timeclock-ui-interval-test-5 ()
  (should (= (interval-test 5 0) 5))
  (should (= (interval-test 5 1) 4))
  (should (= (interval-test 5 2) 3))
  (should (= (interval-test 5 3) 2))
  (should (= (interval-test 5 4) 1))
  (should (= (interval-test 5 5) 7))
  (should (= (interval-test 5 6) 6)))

(ert-deftest timeclock-ui-interval-test-6 ()
  (should (= (interval-test 6 0) 6))
  (should (= (interval-test 6 1) 5))
  (should (= (interval-test 6 2) 4))
  (should (= (interval-test 6 3) 3))
  (should (= (interval-test 6 4) 2))
  (should (= (interval-test 6 5) 1))
  (should (= (interval-test 6 6) 7)))

(ert-deftest timeclock-ui-previous-week-start-sunday ()
  (let ((timeclock-report-week-start-day "Sunday"))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 1 9 2018 6 nil 19800))
                   '(0 0 0 26 8 2018 0 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 2 9 2018 0 nil 19800))
                   '(0 0 0 2  9 2018 0 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 3 9 2018 1 nil 19800))
                   '(0 0 0 2  9 2018 0 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 4 9 2018 2 nil 19800))
                   '(0 0 0 2  9 2018 0 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 5 9 2018 3 nil 19800))
                   '(0 0 0 2  9 2018 0 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 6 9 2018 4 nil 19800))
                   '(0 0 0 2  9 2018 0 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 7 9 2018 5 nil 19800))
                   '(0 0 0 2  9 2018 0 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 8 9 2018 6 nil 19800))
                   '(0 0 0 2  9 2018 0 nil 19800)))))

(ert-deftest timeclock-ui-previous-week-start-monday ()
  (let ((timeclock-report-week-start-day "Monday"))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 1 9 2018 6 nil 19800))
                   '(0 0 0 27 8 2018 1 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 2 9 2018 0 nil 19800))
                   '(0 0 0 27 8 2018 1 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 3 9 2018 1 nil 19800))
                   '(0 0 0 3  9 2018 1 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 4 9 2018 2 nil 19800))
                   '(0 0 0 3  9 2018 1 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 5 9 2018 3 nil 19800))
                   '(0 0 0 3  9 2018 1 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 6 9 2018 4 nil 19800))
                   '(0 0 0 3  9 2018 1 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 7 9 2018 5 nil 19800))
                   '(0 0 0 3  9 2018 1 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 8 9 2018 6 nil 19800))
                   '(0 0 0 3  9 2018 1 nil 19800)))))

(ert-deftest timeclock-ui-previous-week-start-tuesday ()
  (let ((timeclock-report-week-start-day "Tuesday"))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 1 9 2018 6 nil 19800))
                   '(0 0 0 28 8 2018 2 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 2 9 2018 0 nil 19800))
                   '(0 0 0 28 8 2018 2 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 3 9 2018 1 nil 19800))
                   '(0 0 0 28 8 2018 2 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 4 9 2018 2 nil 19800))
                   '(0 0 0 4  9 2018 2 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 5 9 2018 3 nil 19800))
                   '(0 0 0 4  9 2018 2 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 6 9 2018 4 nil 19800))
                   '(0 0 0 4  9 2018 2 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 7 9 2018 5 nil 19800))
                   '(0 0 0 4  9 2018 2 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 8 9 2018 6 nil 19800))
                   '(0 0 0 4  9 2018 2 nil 19800)))))

(ert-deftest timeclock-ui-previous-week-start-wednesday ()
  (let ((timeclock-report-week-start-day "Wednesday"))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 1 9 2018 6 nil 19800))
                   '(0 0 0 29 8 2018 3 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 2 9 2018 0 nil 19800))
                   '(0 0 0 29 8 2018 3 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 3 9 2018 1 nil 19800))
                   '(0 0 0 29 8 2018 3 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 4 9 2018 2 nil 19800))
                   '(0 0 0 29 8 2018 3 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 5 9 2018 3 nil 19800))
                   '(0 0 0 5  9 2018 3 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 6 9 2018 4 nil 19800))
                   '(0 0 0 5  9 2018 3 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 7 9 2018 5 nil 19800))
                   '(0 0 0 5  9 2018 3 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 8 9 2018 6 nil 19800))
                   '(0 0 0 5  9 2018 3 nil 19800)))))

(ert-deftest timeclock-ui-previous-week-start-thursday ()
  (let ((timeclock-report-week-start-day "Thursday"))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 1 9 2018 6 nil 19800))
                   '(0 0 0 30 8 2018 4 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 2 9 2018 0 nil 19800))
                   '(0 0 0 30 8 2018 4 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 3 9 2018 1 nil 19800))
                   '(0 0 0 30 8 2018 4 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 4 9 2018 2 nil 19800))
                   '(0 0 0 30 8 2018 4 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 5 9 2018 3 nil 19800))
                   '(0 0 0 30 8 2018 4 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 6 9 2018 4 nil 19800))
                   '(0 0 0 6  9 2018 4 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 7 9 2018 5 nil 19800))
                   '(0 0 0 6  9 2018 4 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 8 9 2018 6 nil 19800))
                   '(0 0 0 6  9 2018 4 nil 19800)))))

(ert-deftest timeclock-ui-previous-week-start-friday ()
  (let ((timeclock-report-week-start-day "Friday"))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 1 9 2018 6 nil 19800))
                   '(0 0 0 31 8 2018 5 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 2 9 2018 0 nil 19800))
                   '(0 0 0 31 8 2018 5 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 3 9 2018 1 nil 19800))
                   '(0 0 0 31 8 2018 5 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 4 9 2018 2 nil 19800))
                   '(0 0 0 31 8 2018 5 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 5 9 2018 3 nil 19800))
                   '(0 0 0 31 8 2018 5 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 6 9 2018 4 nil 19800))
                   '(0 0 0 31 8 2018 5 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 7 9 2018 5 nil 19800))
                   '(0 0 0 7  9 2018 5 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 8 9 2018 6 nil 19800))
                   '(0 0 0 7  9 2018 5 nil 19800)))))

(ert-deftest timeclock-ui-previous-week-start-saturday ()
  (let ((timeclock-report-week-start-day "Saturday"))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 30 8 2018 4 nil 19800))
                   '(0 0 0 25 8 2018 6 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 31 8 2018 5 nil 19800))
                   '(0 0 0 25 8 2018 6 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 2 9 2018 0 nil 19800))
                   '(0 0 0 1  9 2018 6 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 3 9 2018 1 nil 19800))
                   '(0 0 0 1  9 2018 6 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 4 9 2018 2 nil 19800))
                   '(0 0 0 1  9 2018 6 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 5 9 2018 3 nil 19800))
                   '(0 0 0 1  9 2018 6 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 6 9 2018 4 nil 19800))
                   '(0 0 0 1  9 2018 6 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 7 9 2018 5 nil 19800))
                   '(0 0 0 1  9 2018 6 nil 19800)))
    (should (equal (timeclock-report-previous-week-start '(0 0 0 8 9 2018 6 nil 19800))
                   '(0 0 0 8  9 2018 6 nil 19800)))))

(ert-deftest timeclock-ui-ptod-tests ()
  "Tests for `timeclock-ui-project-time-one-day'."
  (let ((timeclock-file "test.timelog"))
    (timeclock-reread-log)
    ;; basic 1 hour test
    (should (equal (timeclock-ui-project-time-one-day "Programming" '(0 0 0 1 1 2018))
                   [1 0 0]))
    (should (equal (timeclock-ui-project-time-one-day "Swimming"    '(0 0 0 1 1 2018))
                   [1 0 0]))
    (should (equal (timeclock-ui-project-time-one-day "Cooking"     '(0 0 0 1 1 2018))
                   [1 0 0]))
    (should (equal (timeclock-ui-project-time-one-day "Guitar"      '(0 0 0 1 1 2018))
                   [1 0 0]))
    (should (equal (timeclock-ui-project-time-one-day "Cycling"     '(0 0 0 1 1 2018))
                   [1 0 0]))
    ;; across midnight
    (should (equal (timeclock-ui-project-time-one-day "Programming" '(0 0 0 2 1 2018))
                   [1 0 0]))
    (should (equal (timeclock-ui-project-time-one-day "Programming" '(0 0 0 3 1 2018))
                   [1 0 0]))))

(ert-deftest timeclock-list-seconds-to-hms-tests ()
  (should (equal (timeclock-list-seconds-to-hms 1)
                 [0 0 1]))
  (should (equal (timeclock-list-seconds-to-hms 60)
                 [0 1 0]))
  (should (equal (timeclock-list-seconds-to-hms 61)
                 [0 1 1]))
  (should (equal (timeclock-list-seconds-to-hms 3600)
                 [1 0 0]))
  (should (equal (timeclock-list-seconds-to-hms 3660)
                 [1 1 0]))
  (should (equal (timeclock-list-seconds-to-hms 3661)
                 [1 1 1])))

(ert-deftest timeclock-list-time-add-tests ()
  "Tests for `timeclock-list-time-add'."
  (should (equal (timeclock-list-time-add [0 0 0] [0 0 0])
                 [0 0 0]))
  (should (equal (timeclock-list-time-add [0 0 1] [0 0 0])
                 [0 0 1]))
  (should (equal (timeclock-list-time-add [0 0 1] [0 0 59])
                 [0 1 0]))
  (should (equal (timeclock-list-time-add [0 1 0] [0 0 1])
                 [0 1 1]))
  (should (equal (timeclock-list-time-add [0 1 1] [0 59 59])
                 [1 1 0])))

(ert-deftest timeclock-list-ttod-tests ()
  "Tests for `timeclock-list-total-time-one-day'."
  (let ((timeclock-file "test.timelog"))
    (timeclock-reread-log)
    (should (equal (timeclock-list-total-time-one-day '(0 0 0 1 1 2018))
                   [5 0 0]))
    (should (equal (timeclock-list-total-time-one-day '(0 0 0 2 1 2018))
                   [1 0 0]))
    (should (equal (timeclock-list-total-time-one-day '(0 0 0 3 1 2018))
                   [1 0 0]))))

;; (ert-deftest timeclock-report-iodd-tests ()
;;   (should (equal (timeclock-report-increment-or-decrement-date '(0 0 0 28 2 2020) '+))))

(provide 'timeclock-ui-tests)

;; Local Variables:
;; nameless-current-name: "timeclock-ui"
;; End:
